from pathlib import Path
# data source dir
data_src = Path("data_src")
## sub dirs
csv_src = data_src / "csv"
excel_src = data_src / "excel"
xml_src = data_src / "xml"

## csv sources
fbis_interfaces = csv_src / "fbis_interfaces.csv"
fast_frame = csv_src / "fast_frame_tbl.csv"

## excel sources
fbis_interface_design_spec = excel_src / "ESS-0715539 - FBIS interface design specification.xlsx"
fbis_signal_configuration = excel_src / "ESS-3049041 - Attachment-01 FBIS-Signal Configuration.xlsx"
latching_rules = fbis_signal_configuration / "General Rules"

## xml sources
chess_xml = xml_src / "chess.xml"

datasources = [fbis_interfaces,
               fbis_interface_design_spec,
               fbis_signal_configuration,
               chess_xml]

database_srcs = [fbis_interfaces,
                 fbis_interface_design_spec,
                 fbis_signal_configuration,
                 latching_rules,
                 fast_frame]

# database
db_name = Path("database.db")