def main():
    import sqlite3
    import pandas as pd

    from configuration import db_name, datasources
    import modules.database as database
    from modules.datasources.initialize import initialize_dir_structure
    from modules.datasources.get.get import get

    from modules.database.queries.queries import (dln_test_data_sql,
                                                  latch_rules_sql)
    from modules.database.queries.user_defined_function import (user_defined_functions)

    # initialize_dir_structure()
    # list(map(get,datasources))

    database.initialize(db_name)

    conn = sqlite3.connect(db_name)
    for func_name,num_args,func in user_defined_functions:
        conn.create_function(func_name,num_args,func)

    df = pd.read_sql(dln_test_data_sql,conn)
    print(df)
    df.to_csv("test.csv",index=False)
    return None


if __name__ == "__main__":
    main()
