from configuration import database_srcs
from modules.datasources.parse.parse import parse

from pathlib import Path
import sqlite3

def make_table_name(data_src:Path)->str:
    string = str(data_src)
    print(string)
    if "fbis_interfaces" in string:
        return "fbis_interfaces"
    elif "FBIS interface design specification" in string:
        return "fbis_interface_design_specification"
    elif "General Rules" in string:
        return "latching_rules"
    elif "FBIS-Signal Configuration" in string:
        return "fbis_signal_configuration"
    elif "fast_frame" in string:
        return "fast_frame"

def initialize(db_name:Path):
    if not db_name.exists():
        print("Initializing database")
        conn = sqlite3.connect(db_name)
        dfs = list(map(parse,database_srcs))
        for path, df in zip(database_srcs,dfs):
            print(path,df)
            table_name = make_table_name(path)
            print(f"Creating table {table_name}")
            df.to_sql(table_name,conn)
    return None

