# Methods for filter
## Methods for makeing_filter_conditions_pbd_field
def is_isrc(filtering_beam_destinations:str)->bool:
    return "isrc" in filtering_beam_destinations

def is_lebt(filtering_beam_destinations:str)->bool:
    return "lebt" in filtering_beam_destinations

def is_mebt(filtering_beam_destinations:str)->bool:
    return "mebt" in filtering_beam_destinations

def is_dtl2(filtering_beam_destinations:str)->bool:
    return "dtl2" in filtering_beam_destinations

def is_dtl4(filtering_beam_destinations:str)->bool:
    return "dtl4" in filtering_beam_destinations

def is_spk(filtering_beam_destinations:str)->bool:
    return "spk" in filtering_beam_destinations

def is_mbl(filtering_beam_destinations:str)->bool:
    return "mbl" in filtering_beam_destinations

def is_tbd(filtering_beam_destinations:str)->bool:
    return "tbd" in filtering_beam_destinations

def is_trg(filtering_beam_destinations:str)->bool:
    if "trg" in filtering_beam_destinations:
        return True
    elif "tgt" in filtering_beam_destinations:
        return True
    else:
        return False

def is_all_but_trg(filtering_beam_destinations:str)->bool:
    return "all but target" in filtering_beam_destinations

def is_all_but_tbd(filtering_beam_destinations:str)->bool:
    return "all but tuning dump" in filtering_beam_destinations


def encode_filtering_beam_destination(filtering_beam_destination:str)->str:
    destination_states = {"isrc":0,
                          "lebt":0,
                          "mebt":0,
                          "dtl2":0,
                          "dtl4":0,
                          "spk":0,
                          "mbl":0,
                          "tbd":0,
                          "trg":0}
    keys = list(destination_states)
    checkers = [is_isrc,is_lebt,is_mebt,is_dtl2,
                is_dtl4,is_spk,is_mbl,is_tbd,
                is_trg]
    encode = ""
    for key, checker in zip(keys,checkers):
        if checker(filtering_beam_destination.lower()):
            destination_states[key] = 1
        encode += str(destination_states[key])

    if is_all_but_tbd(filtering_beam_destination.lower()):
        return "111111101"
    if is_all_but_trg(filtering_beam_destination.lower()):
        return "111111110"
    return encode

def make_filter_conditions_pbd_field_udf(filtering_beam_destination:str)->int:
    code = encode_filtering_beam_destination(filtering_beam_destination)
    power = 1
    for bit in code:
        if bit == '1':
            power *= 2
    return power-1

## Methods for makeing_filter_conditions_pbm_field
def encode_filtering_beam_mode(filtering_beam_mode:str)->str:
    return '000000000000'

def make_filter_conditions_pbm_field_udf(filtering_beam_mode:str)->int:
    code = encode_filtering_beam_mode(filtering_beam_mode)
    power = 1
    for bit in code:
        if bit == '1':
            power *= 2
    return power-1

# Methods for mask
## Methods for making_mask_conditions_pbd_field
def encode_masking_beam_destination(masking_beam_destination:str)->str:
    return '111111111'

def make_mask_conditions_pbd_field_udf(masking_beam_destination:str)->int:
    code = encode_masking_beam_destination(masking_beam_destination)
    power = 1
    for bit in code:
        if bit == '1':
            power *= 2
    return power-1

## Methods for making_mask_conditions_pbm_field
def encode_masking_beam_mode(masking_beam_mode:str)->str:
    return '111111111111'

def make_mask_conditions_pbm_field_udf(masking_beam_mode:str)->int:
    code = encode_masking_beam_mode(masking_beam_mode)
    power = 1
    for bit in code:
        if bit == '1':
            power *= 2
    return power-1

def make_mask_enable_field_udf()->int:
    return 1

## Methods



# Methods for make_filter_enable_field
def make_filter_enable_field_udf(filtering_beam_destinations:str,filtering_beam_modes:str)->int:
    filter_conditions_pbd = make_filter_conditions_pbd_field_udf(filtering_beam_destinations)
    filter_conditions_pbm = make_filter_conditions_pbm_field_udf(filtering_beam_modes)
    return filter_conditions_pbd > 0 or filter_conditions_pbm > 0

# Methods for make_latch_enable_field
def make_latch_enable_field_udf(latching_latchable:str)->bool:
    if latching_latchable == "Yes":
        return True
    elif latching_latchable == "No":
        return False
    elif latching_latchable == "Latchable":
        return False
    else:
        assert False, f"Case {latching_latchable} not taken care of"
    
# Methods for make_latcht_default_field
def make_latch_default_field(latching_latchable:str,
                             signals_signal_type:str,
                             signals_signal_name:str)->str:
    ...


# Methods for make_alias_field
def make_alias_field_rf(signals_signal_name:str,interlock_device_name:str)->str:
    if "Red_Beam_Permit" == signals_signal_name:
        return interlock_device_name + ":FBIS-Red-BP"
    elif "Beam_Permit" == signals_signal_name:
        return interlock_device_name + ":FBIS-BP"
    else:
        return ''

def make_alias_field_bpm(signals_signal_name:str,interlock_device_name:str)->str:
    if "Beam Permit Position" == signals_signal_name:
        return interlock_device_name + ":FBIS-BP"
    elif "Ready" == signals_signal_name:
        return interlock_device_name + ":FBIS-Rdy"
    elif "Beam Permit Energy"  == signals_signal_name:
        return interlock_device_name + ":FBIS-BPE"

def make_alias_field_blm(signals_signal_name:str,interlock_device_name:str)->str:
    if "Beam_Permit" == signals_signal_name:
        return interlock_device_name + ":FBIS-BP"
    elif "Ready" == signals_signal_name:
        return interlock_device_name + ":FBIS-Rdy"
    elif "Red_Beam_Permit" == signals_signal_name:
        return interlock_device_name + ":FBIS-Red-BP"
    elif "Red_Ready" == signals_signal_name:
        return interlock_device_name + ":FBIS-Red-Rdy"


def make_alias_field_bcm01(signals_signal_name:str,interlock_device_name:str)->str:
    return None
def make_alias_field_bcm02(signals_signal_name:str,interlock_device_name:str)->str:
    return None
def make_alias_field_bcm0x(signals_signal_name:str,interlock_device_name:str)->str:
    if "Beam Permit" == signals_signal_name:
        return interlock_device_name + ":FBIS-BP"
    elif "Ready" == signals_signal_name:
        return interlock_device_name + ":FBIS-Rdy"
    elif "DL_Beam_Permit" == signals_signal_name:
        return interlock_device_name + ":FBIS-BP-DL"
    elif "DL_Ready" == signals_signal_name:
        return interlock_device_name + ":FBIS-Rdy-DL"
    elif "DL_PBD" == signals_signal_name:
        return interlock_device_name + ":FBIS-BD-Cfg"
    elif "DL_PBM" == signals_signal_name:
        return interlock_device_name + ":FBIS-BM-Cfg"
    return None

def make_alias_field_bcm(system_name:str,
                         signals_signal_name:str,
                         interlock_device_name:str):
    if "01" in system_name:
        return make_alias_field_bcm01(signals_signal_name,interlock_device_name)
    elif "02" in system_name:
        return make_alias_field_bcm02(signals_signal_name,interlock_device_name)
    else:
        return make_alias_field_bcm0x(signals_signal_name,interlock_device_name)

def is_device_type(system_name:str,device_type:str)->bool:
    return device_type in system_name

is_rflps = lambda system_name: is_device_type(system_name,"RFLPS")
is_bpm = lambda system_name: is_device_type(system_name,"BPM")
is_blm = lambda system_name: is_device_type(system_name,"BLM")
is_bcm = lambda system_name: is_device_type(system_name,"BCM")

def make_alias_field_udf(system_name:str,
                         signals_signal_name:str,
                         interlock_device_name:str)->str:
    if is_rflps(system_name):
        return make_alias_field_rf(signals_signal_name,interlock_device_name)
    elif is_bpm(system_name):
        return make_alias_field_bpm(signals_signal_name,interlock_device_name)
    elif is_blm(system_name):
        return make_alias_field_blm(signals_signal_name,interlock_device_name)
    elif is_bcm(system_name):
        return make_alias_field_bcm(system_name,signals_signal_name,interlock_device_name)

# Functions for making signal_index_offset
def make_signal_index_offset_blm(signals_signal_name:str,subslot:int)->int:
    index = {"Beam_Permit":0,
             "Ready":1,
             "Red_Beam_Permit":2,
             "Red_Ready":3,
             "Signal name":0}
    return index[signals_signal_name] + 4*(int(subslot)-1)
def make_signal_index_offset_bpm(signals_signal_name:str,subslot:int)->int:
    if "Beam_Permit" == signals_signal_name:
        i = 0
    elif "Ready" == signals_signal_name:
        i = 1
    else:
        i = 0
    return i + 4*(int(subslot)-1)
def make_signal_index_offset_rf(signals_signal_name:str,subslot:int)->int:
    if "Red_Beam_Permit" == signals_signal_name:
        i = 2
    elif "Beam_Permit" == signals_signal_name:
        i = 1
    else:
        i = 1
    return (i-1)*2+(int(subslot)-1)*4

def make_signal_index_offset_bcm01(signals_signal_name:str,subslot:int)->int:
    return 0

def make_signal_index_offset_bcm02(signals_signal_name:str,subslot:int)->int:
    return 0

def make_signal_index_offset_bcm0x(signals_signal_name:str,subslot:int)->int:
    if "Beam Permit" == signals_signal_name:
        return 1
    elif "Ready" == signals_signal_name:
        return 2
    else:
        return 0

def make_signal_index_offset_bcm(system_name:str,signals_signal_name:str,subslot:int)->int:
    if "01" in system_name:
        return make_signal_index_offset_bcm01(signals_signal_name,subslot)
    elif "02" in system_name:
        return make_signal_index_offset_bcm02(signals_signal_name,subslot)
    else:
        return make_signal_index_offset_bcm0x(signals_signal_name,subslot)

def make_signal_index_offset(system_name:str,signals_signal_name:str,subslot:int)->int:
    if is_rflps(system_name):
        return make_signal_index_offset_rf(signals_signal_name,subslot)
    elif is_bpm(system_name):
        return make_signal_index_offset_bpm(signals_signal_name,subslot) 
    elif is_blm(system_name):
        return make_signal_index_offset_blm(signals_signal_name,subslot) 
    elif is_bcm(system_name):
        return make_signal_index_offset_bcm(system_name,signals_signal_name,subslot)
    else:
        return 0

def make_base_index_udf(system_name:str,
                    signals_signal_name:str,
                    signals_signal_type:str,
                    subslot:int,
                    base_index_ff:int,
                    base_index_nd:int)->int:
    signal_index_offset = make_signal_index_offset(system_name,signals_signal_name,subslot)
    if signals_signal_type.lower() == "discrete":
        return  signal_index_offset + base_index_ff
    else:
        return signal_index_offset + base_index_nd


#Method for latching_rule_code
is_redundant = lambda signal_name: "redundant" in signal_name or "red_" in signal_name
is_beam_permit = lambda signal_name:"beam_permit" in signal_name or "beam permit" in signal_name
is_ready = lambda signal_name: "ready" in signal_name
is_pbm = lambda signal_name: "pbm" in signal_name
is_pbd = lambda signal_name: "pbd" in signal_name
is_beam_absence = lambda signal_name: "beam_absence" in signal_name
is_hv_absence = lambda signal_name: "hv_absence" in signal_name
is_hv_extract = lambda signal_name: "hv_extract" in signal_name
is_chopping_fault = lambda signal_name: "chopping" in signal_name
is_feed_back = lambda signal_name: "feedback" in signal_name
is_high_level_safety = lambda signal_name: "highlevel_safety" in signal_name
def encode_latch_rules_discrete_red_signal(signal_name:str)->str:
    if is_beam_permit(signal_name):
        return "discrete_red_bp"
    elif is_ready(signal_name):
        return "dicrete_red_rdy"
    else:
        msg = f"encode_latch_rules_discrete_red_signal: Case not handled for signal_name {signal_name}"
        print(msg)
        assert False,msg

def encode_latch_rules_discrete_signal(signal_name:str)->str:
    if is_beam_permit(signal_name):
        return "discrete_bp"
    elif is_ready(signal_name):
        return "discrete_rdy"
    elif is_beam_absence(signal_name):
        return "discrete_beam_absence"
    elif is_chopping_fault(signal_name):
        return "discrete_chopping_fault"
    elif is_feed_back(signal_name):
        return "discrete_feedback"
    elif is_high_level_safety(signal_name):
        return "discrete_highlevel_safety"
    else:
        msg = f"encode_latch_rules_discrete_signal: Case not handled for signal_name {signal_name}"
        print(msg)
        assert False,msg


def encode_latch_rules_discrete(signal_name:str)->str:
    if is_redundant(signal_name):
        return encode_latch_rules_discrete_red_signal(signal_name)
    else:
        return encode_latch_rules_discrete_signal(signal_name)

def encode_latch_rules_datalink(signal_name:str)->str:
    if is_beam_permit(signal_name):
        return "dl_bp"
    elif is_ready(signal_name):
        return "dl_rdy"
    elif is_pbm(signal_name):
        return "dl_pbm"
    elif is_pbd(signal_name):
        return "dl_pbd"
    elif is_beam_absence(signal_name):
        return "dl_beam_absence"
    elif is_hv_absence(signal_name):
        return "dl_hv_absence"
    elif is_hv_extract(signal_name):
        return "dl_hv_extract"
    elif is_feed_back(signal_name):
        return "dl_feedback"
    else:
        msg = f"encode_latch_rules_datalink: Case not handled for signal_name {signal_name}"
        print(msg)
        assert False,msg



def encode_latch_rules_software(signal_name:str)->str:
    if is_beam_permit(signal_name):
        return "discrete_bp"
    elif is_ready(signal_name):
        return "discrete_rdy"
    elif is_pbm(signal_name):
        return "dl_pbm"
    elif is_pbd(signal_name):
        return "dl_pbsignal_connectiond"
    else:
        msg = f"encode_latch_rules_software: Case not handled for signal_name {signal_name}"
        assert False,msg

def encode_latch_rules_udf(signal_name:str,signal_type:str)->str:
    '''
        Function used on latching_rules and fbis_signal_config table to create a coded field.
    '''
    lower_signal_name = signal_name.replace(" ","_").lower()
    lower_signal_type = signal_type.lower()
    is_discrete = "discrete" in lower_signal_type
    is_datalink = "datalink" in lower_signal_type
    is_software = "software" in lower_signal_type
    if is_discrete:
        return encode_latch_rules_discrete(lower_signal_name)
    elif is_datalink:
        return encode_latch_rules_datalink(lower_signal_name)
    elif is_software:
        return encode_latch_rules_software(lower_signal_name)
    else:
        msg = f'''encode_latch_rules_udf:Signal type case {lower_signal_type} {type(lower_signal_name)} not taken care of'''
        print(msg)
        assert False, msg

def make_latch_default_field_udf(latching_latchable:str,latch_description:str)->str:
    if latching_latchable == "No":
        return "not latched"
    elif latching_latchable == "Yes":
        return latch_description
    else:
        assert False, f"Case not defined for {latching_latchable}"



#Method for make_slink_origin_fast_field
def make_slink_origin_fast_field_udf(signals_signal_type:str)->str:
    if "discrete" == signals_signal_type.lower():
        return True
    else:
        return False

#Method for make_pu_type_field
def make_pu_type_udf(signals_signal_name:str)->str:
    lower = signals_signal_name.lower()
    if "pbm" in lower:
        return "pbmspu"
    elif "pbd" in lower:
        return "pbdspu"
    elif "feedback" in lower:
        return "sspu"
    else:
        return "spu"

import inspect
user_defined_functions = []
for key in dir():
    if "_udf" in key:
        func_name = key.replace("_udf","")
        func_obj = globals()[key]
        num_func_args = len(inspect.signature(func_obj).parameters)
        user_defined_functions.append((func_name,num_func_args,func_obj))