from pathlib import Path
import modules.datasources.get.chess_xml as get_chess_xml
import modules.datasources.get.fbis_signal_configuration as get_fbis_signal_configuration
import modules.datasources.get.fbis_interface_design_spec as get_fbis_interface_design_spec
import modules.datasources.get.fbis_interfaces as get_fbis_interfaces


def get(data_src:Path)->None:
    from configuration import (
        fbis_interfaces,
        fbis_interface_design_spec,
        fbis_signal_configuration,
        chess_xml
    )
    if str(data_src) == str(chess_xml):
        get_chess_xml.get(data_src)
    elif str(data_src) == str(fbis_interface_design_spec):
        get_fbis_interface_design_spec.get(data_src)
    elif str(data_src) == str(fbis_signal_configuration):
        get_fbis_signal_configuration.get(data_src)
    elif str(data_src) == str(fbis_interfaces):
        get_fbis_interfaces.get(data_src)
    else:
        assert False, f"Case {str(data_src)} not taken care of"

