from pathlib import Path
import pandas as pd

from modules.datasources.parse.utilities import make_csv_name
from modules.datasources.parse.utilities import process_field_names

def parse(data_path:Path)->pd.DataFrame:
    excel_file = pd.ExcelFile(data_path)
    sheet_names = ["FBIS SS Connections","FBIS Actuators Connections"]
    dfs = []
    for sheet_name in sheet_names:
        df = excel_file.parse(sheet_name,skiprows=3)
        df.columns = process_field_names(df.columns.values.tolist())
        dfs.append(df)
        
    union_of_sheets = pd.concat(dfs)
    union_of_sheets.to_csv(make_csv_name(data_path),index=False)
    return union_of_sheets
