from pathlib import Path
import pandas as pd

import modules.datasources.parse.fbis_interface_design_spec as fbis_interface_design_spec
import modules.datasources.parse.fbis_signal_configuration as fbis_signal_configuration
import modules.datasources.parse.csv as csv

def parse(data_path:Path)->pd.DataFrame:
    string = str(data_path)
    if "FBIS interface design specification" in string:
        return fbis_interface_design_spec.parse(data_path)
    elif "FBIS-Signal Configuration" in string:
        return fbis_signal_configuration.parse(data_path)
    elif "fbis_interfaces.csv" in string:
        return csv.parse(data_path)
    elif "fast_frame" in string:
        return csv.parse(data_path)